hammingMatcher

Functions
hammingMatcher
Complete List of ArrayFire Functions ArrayFire Functions by Category » Computer Vision » | Feature matchers

Hamming Matcher. More...

## Functions
AFAPI void | hammingMatcher (array &idx, array &dist, const array &query, const array &train, const dim_t dist_dim=0, const unsigned n_dist=1)
| C++ Interface wrapper for Hamming matcher. More...
AFAPI af_err | af_hamming_matcher (af_array *idx, af_array *dist, const af_array query, const af_array train, const dim_t dist_dim, const unsigned n_dist)
| C Interface wrapper for Hamming matcher. More...

## Detailed Description

Hamming Matcher.

Calculates Hamming distances between two 2-dimensional arrays containing features, one of the arrays containing the training data and the other the query data. One of the dimensions of the both arrays must be equal among them, identifying the length of each feature. The other dimension indicates the total number of features in each of the training and query arrays. Two 1-dimensional arrays are created as results, one containg the smallest N distances of the query array and another containing the indices of these distances in the training array. The resulting 1-dimensional arrays have length equal to the number of features contained in the query array.

## Function Documentation

## § af_hamming_matcher()

AFAPI af_err af_hamming_matcher | ( | af_array * | idx,
|  | af_array * | dist,
|  | const af_array | query,
|  | const af_array | train,
|  | const dim_t | dist_dim,
|  | const unsigned | n_dist
| ) |  |

C Interface wrapper for Hamming matcher.

Parameters

  [out] | idx | is an array of MxN size, where M is equal to the number of query features and N is equal to n_dist. The value at position IxJ indicates the index of the Jth smallest distance to the Ith query value in the train data array. the index of the Ith smallest distance of the Mth query.
  [out] | dist | is an array of MxN size, where M is equal to the number of query features and N is equal to n_dist. The value at position IxJ indicates the Hamming distance of the Jth smallest distance to the Ith query value in the train data array.
  [in] | query | is the array containing the data to be queried
  [in] | train | is the array containing the data used as training data
  [in] | dist_dim | indicates the dimension to analyze for distance (the dimension indicated here must be of equal length for both query and train arrays)
  [in] | n_dist | is the number of smallest distances to return (currently, only 1 is supported)

## § hammingMatcher()

AFAPI void af::hammingMatcher | ( | array & | idx,
|  | array & | dist,
|  | const array & | query,
|  | const array & | train,
|  | const dim_t | dist_dim = `0`,
|  | const unsigned | n_dist = `1`
| ) |  |

C++ Interface wrapper for Hamming matcher.

Parameters

  [out] | idx | is an array of MxN size, where M is equal to the number of query features and N is equal to n_dist. The value at position IxJ indicates the index of the Jth smallest distance to the Ith query value in the train data array. the index of the Ith smallest distance of the Mth query.
  [out] | dist | is an array of MxN size, where M is equal to the number of query features and N is equal to n_dist. The value at position IxJ indicates the Hamming distance of the Jth smallest distance to the Ith query value in the train data array.
  [in] | query | is the array containing the data to be queried
  [in] | train | is the array containing the data used as training data
  [in] | dist_dim | indicates the dimension to analyze for distance (the dimension indicated here must be of equal length for both query and train arrays)
  [in] | n_dist | is the number of smallest distances to return (currently, only 1 is supported)

Note
  Note: This is a special case of the nearestNeighbour function with AF_SHD as dist_type